/*
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  Author: Massimiliano Culpo (m.culpo@cineca.it)
*/

#ifndef MATRIX_MULTIPLY_TIMING_H_
#define MATRIX_MULTIPLY_TIMING_H_

#include <stdint.h>

typedef uint64_t clockmark_t;

clockmark_t timing_nsec(const clockmark_t* const start, const clockmark_t* const end);
double      timing_sec (const clockmark_t* const start, const clockmark_t* const end);
clockmark_t timing_getmark(void);

#endif
